//
//  AppLauncherView.m
//  MultiWindow
//
//  Created by Marimuthu on 20/07/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "AppLauncherView.h"


@implementation AppLauncherView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
		nNoOfApps = 50;
    }
    return self;
}



-(void) drawCircle
{
	NSRect frameRect = [self frame];
	// Get the graphics context that we are currently executing under
    NSGraphicsContext* gc = [NSGraphicsContext currentContext];
	
    // Save the current graphics context settings
    [gc saveGraphicsState];
	
    // Set the color in the current graphics context for future draw operations
    [[NSColor blackColor] setStroke];
    [[NSColor blackColor] setFill];
	
    // Create our circle path
    NSRect rect = NSMakeRect(frameRect.origin.x+ frameRect.size.width-3, frameRect.origin.y + (frameRect.size.height/2), 1, 1);
    NSBezierPath* circlePath = [NSBezierPath bezierPath];

	//Centre dot
    [circlePath appendBezierPathWithOvalInRect: rect];	
    // Outline and fill the path
    [circlePath stroke];
    [circlePath fill];
	
	//upper dot
	NSRect upperRect = rect;
	upperRect.origin.y = rect.origin.y - 6;
    [circlePath appendBezierPathWithOvalInRect: upperRect];	
    // Outline and fill the path
    [circlePath stroke];
    [circlePath fill];
	
	
	//lower dot
	NSRect bottomRect = rect;
	bottomRect.origin.y = rect.origin.y + 6;
    [circlePath appendBezierPathWithOvalInRect: bottomRect];	
    // Outline and fill the path
    [circlePath stroke];
    [circlePath fill];
	
	
    // Restore the context to what it was before we messed with it
    [gc restoreGraphicsState];
}



- (void)drawRect:(NSRect)dirtyRect {
	
	//Circular edges.
	NSBezierPath* roundRectPath = [NSBezierPath bezierPathWithRoundedRect: [self bounds] xRadius:10 yRadius:10]; 
    [roundRectPath addClip];
	
	float red= 38/255.0; //26 in HEX
	float green= 143/255.0; // 8F in HEX
	float blue= 191/255.0; //BF in HEX
	NSColor *color=[NSColor colorWithCalibratedRed:red green:green blue:blue alpha:1.0];
	[color setFill];
	[color setStroke];
	[roundRectPath stroke];
	[roundRectPath fill];
	//Circular edges
	
	[self drawCircle];

}

//-(void) enablemouseTracking
//{
//	return;
//	if(trackingArea)
//	{
//		[self removeTrackingArea:trackingArea];
//		[trackingArea release];
//	}
//	NSTrackingAreaOptions options = NSTrackingInVisibleRect | NSTrackingMouseEnteredAndExited |NSTrackingMouseMoved| NSTrackingActiveInKeyWindow;
//	trackingArea = [[NSTrackingArea alloc] initWithRect:[[self window] frame] options:options owner:self userInfo:nil];
//	[self addTrackingArea:trackingArea];
//	
//}

- (void) viewWillMoveToWindow:(NSWindow *)newWindow {
	NSLog(@"viewWillMoveToWindow");
	if(trackingArea2)
	{
		[self removeTrackingArea:trackingArea2];
		[trackingArea2 release];
	}
    // Setup a new tracking area when the view is added to the window.
    trackingArea2 = [[NSTrackingArea alloc] initWithRect:[self frame] options: (NSTrackingMouseEnteredAndExited | NSTrackingActiveAlways) owner:self userInfo:nil];
    [self addTrackingArea:trackingArea2];
}

-(void) awakeFromNib
{
	
	
	[[self window]	setMovableByWindowBackground:NO];
	[[self window] setExcludedFromWindowsMenu:YES];
	[[self window] setAlphaValue:1.0];
	[[self window] setOpaque:NO];
	[[self window] setHasShadow:YES];
	[[self window] useOptimizedDrawing:YES];

	bIsNormalView = YES;
//	normalView = [[self window] frame];
	[[self window] setAcceptsMouseMovedEvents:YES];
	[[self window] setDelegate:self];
	
	//[self enablemouseTracking];
	
	
	// Subscribe to scrolling notification:
	NSClipView *contentView = [[self window] contentView];
	[contentView setPostsBoundsChangedNotifications: YES];
	
    [[NSNotificationCenter defaultCenter] addObserver:self
											 selector:@selector(ViewFrameDidChange:)
	 //name:NSViewBoundsDidChangeNotification
												 name:NSViewFrameDidChangeNotification
											   object:contentView];
	nNoOfApps = 70 ;
	
}

-(void)	ViewFrameDidChange:(NSNotification *)notification
{
//	if(bIsNormalView == NO)
	{
		[self drawQuickLaunchAppButtons];
	}
	NSLog(@"NSViewFrameDidChangeNotification called");
}

- (void)mouseDown:(NSEvent *)theEvent {
//    [self setFrameColor:[NSColor redColor]];
	NSLog(@" App Launcher mouse down");
//	[self resizeToFullView];
//	[self enablemouseTracking];
//    [self setNeedsDisplay:YES];
}

- (void)mouseUp:(NSEvent *)theEvent {
  //  [self setFrameColor:[NSColor greenColor]];
		NSLog(@" App Launcher mouse up");
//	[self resizeToNormalView];
//	[self enablemouseTracking];
//    [self setNeedsDisplay:YES];
}

- (void)mouseMoved:(NSEvent *)theEvent
{
	NSLog(@"Mouse Moved called from App Launcher");
}

- (void)mouseEntered:(NSEvent *)theEvent
{
//	NSLog(@"mouseEntered App Launcher");

	if (normalViewTimer) {
		[normalViewTimer invalidate];
		normalViewTimer = nil;
	}
	if (fullViewTimer) {
		[fullViewTimer invalidate];
		fullViewTimer = nil;
	}
	
	fullViewTimer = [NSTimer scheduledTimerWithTimeInterval:1 
													  target:self 
													selector:@selector(timerFullView) 
													userInfo:nil 
													 repeats:NO]; 	
	NSLog(@"Mouse entered");
}

-(void) timerFullView
{
	if (fullViewTimer) {
		[fullViewTimer invalidate];
		fullViewTimer = nil;
	}
	if(bIsNormalView == YES)
	{
		[self resizeToFullView];
	}
}


- (void)mouseExited:(NSEvent *)theEvent
{
	NSLog(@"mouseExited ");
	
	if (normalViewTimer) {
		[normalViewTimer invalidate];
		normalViewTimer = nil;
	}
	if (fullViewTimer) {
		[fullViewTimer invalidate];
		fullViewTimer = nil;
	}
	
	normalViewTimer = [NSTimer scheduledTimerWithTimeInterval:1 
													 target:self 
												   selector:@selector(timerNormalView) 
												   userInfo:nil 
													repeats:NO]; 	
	
}

-(void) timerNormalView
{
	if (normalViewTimer) {
		[normalViewTimer invalidate];
		normalViewTimer = nil;
	}
	if(bIsNormalView == NO)
	{
		[self resizeToNormalView];
	}
}

-(void) resizeToFullView
{
	
	NSLog(@"resizeToFullView called");
	NSWindow *mainWnd1 = [[self window] parentWindow];
	NSRect MinWndRect = [mainWnd1 frame];
	NSRect two = MinWndRect;
	
	NSRect mainWnd = two;//[[self window] frame];
	NSRect newRect =  mainWnd;
	newRect.origin.x = mainWnd.origin.x + mainWnd.size.width;
	newRect.origin.y = mainWnd.origin.y + 75;
	newRect.size.width = 10;
	newRect.size.height = mainWnd.size.height-150;//* 0.5;//200;
	
	////////////////////////
	bIsNormalView = NO;
	NSRect currentView = newRect;//[[self window] frame];
	NSRect fullView = currentView;
	int NoOfColumn = 1+ 24/8;
	fullView.size.width = currentView.size.width + (NoOfColumn * 30);
		//////[self replaceSubview:<#(NSView *)oldView#> with:<#(NSView *)newView#>
//	[[self window] setFrame:fullView];// display:YES];
		//[[self window] setFrame:fullView  display:YES];

	[[self window] setFrame:fullView display:YES animate:YES];


	//[[self window] update];
}

-(void) moveWindowToNormalPosition
{
	NSLog(@"moveWindoww called in app launcher");

	
	NSWindow *mainWnd1 = [[self window] parentWindow];

	NSRect MinWndRect = [mainWnd1 frame];
	NSRect two = MinWndRect;
	
	NSRect mainWnd = two;//[[self window] frame];
	NSRect newRect =  mainWnd;
	newRect.origin.x = mainWnd.origin.x + mainWnd.size.width;
	newRect.origin.y = mainWnd.origin.y + 75;
	newRect.size.width = 10;
	newRect.size.height = mainWnd.size.height-150;//* 0.5;//200;
	[[self window] setFrame:newRect display:YES animate:YES];

	//[[window2 contentView] setColor: [NSColor blackColor]];
//	[[self window] update];
}


-(void) resizeToNormalView
{
	NSLog(@"resizeToNormalView called");
	[self moveWindowToNormalPosition];
	bIsNormalView = YES;

	return;
	
	
	NSRect currentView = [[self window] frame];
	NSRect fullView = currentView;
	fullView.size.width = 10;//currentView.size.width - 30;
	//////[self replaceSubview:<#(NSView *)oldView#> with:<#(NSView *)newView#>
	//	[[self window] setFrame:fullView];// display:YES];
	//[[self window] setFrame:fullView  display:YES];
	[[self window] setFrame:fullView display:NO animate:YES];
	
	
	//[[self window] update];

}

//- (NSTimeInterval)animationResizeTime:(NSRect)newFrame
//{
//	NSLog(@"animationResizeTime");
//	return 3;
//}

-(NSRect) getReferenceRect;
{
	NSRect entireRect = [self frame];
	return entireRect;
//	NSRect refRect
	
}

-(void) drawQuickLaunchAppButtons
{
	NSRect referenceRect = [self getReferenceRect];
	NSLog(@"%f", referenceRect.size.width);
	
	
//	NSWindow *mainWnd1 = [[self window] parentWindow];
//	
//	NSRect MinWndRect = [mainWnd1 frame];
//	NSRect two = MinWndRect;
//	
//	NSRect mainWnd = two;//[[self window] frame];
//	NSRect newRect =  mainWnd;
//	newRect.origin.x = mainWnd.origin.x + mainWnd.size.width;
//	newRect.origin.y = mainWnd.origin.y + 75;
//	newRect.size.width = referenceRect.size.width;
//	newRect.size.height = referenceRect.size.height;
//	[[self window] setFrame:newRect display:NO animate:NO];

}


-(void) windowDidResize:(NSNotification *)notification
{
	
	//NSLog(@"windowDidResize called");
}
- (void)viewDidMoveToWindow
{
	NSLog(@"viewDidMoveToWindow called");
	
}


- (void)windowDidMove:(NSNotification *)notification
{	NSLog(@"windowDidMove");
	
//	[self drawQuickLaunchAppButtons];
}


@end
